<html lang="en">
<head>
<title>Building Classes - Enhanced Implementation of Emacs Interpreted Objects</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Enhanced Implementation of Emacs Interpreted Objects">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="prev" href="CLOS-compatibility.html#CLOS-compatibility" title="CLOS compatibility">
<link rel="next" href="Default-Superclass.html#Default-Superclass" title="Default Superclass">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Building-Classes"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Default-Superclass.html#Default-Superclass">Default Superclass</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="CLOS-compatibility.html#CLOS-compatibility">CLOS compatibility</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="index.html#Top">Top</a>
<hr>
</div>

<!-- node-name,  next,  previous,  up -->
<h2 class="chapter">3 Building Classes</h2>

<p>A class in EIEIO has a similar structure to that found in other
languages.  A new class is created with <code>defclass</code>

<div class="defun">
&mdash; Function: <b>defclass</b><var> class-name superclass-list slot-list options-or-doc<a name="index-defclass-1"></a></var><br>
<blockquote>
<p>This function is specified by CLOS, and EIEIO conforms in structure.

        <p>Creates a new class called <code>class-name</code>. The created variable's
documentation string is set to a modified version of the doc string
found in <var>options-or-doc</var>.  Each time a slot is defined the
variables documentation string is updated to include the methods
documentation as well.

        <p>The parent class for <code>class-name</code> is <var>superclass-list</var> which
must be a list.  Each element of this list must be a class.  These
classes form the parents of the class being created.  Every slot in
parent is replicated in the new class.  If two parents share the same
slot name, the parent which appears in the list first sets the attributes
for that slot.  If a slot in the new class' slot list matches a parent,
then the new specifications for the child class override that of the
parent.

        <p><var>slot-list</var> is a list of lists.  Each sublist defines an attribute. 
These lists are of the form <code>(name :tag1 value1 :tag2 value2 :tagn
valuen)</code>.  Some valid CLOS tags are:

          <dl>
<dt><code>:initarg</code><dd>The argument used during initialization.  See <a href="Making-New-Objects.html#Making-New-Objects">Making New Objects</a>. 
A good symbol to use for initarg is one that starts with a colon <code>:</code>. 
<br><dt><code>:initform</code><dd>A lisp expression used to generate the default value for this slot. 
If :initform is left out, that slot defaults to being unbound. 
The value passed to initform is automatically quoted.  Thus,
          <pre class="example">               :initform (1 2 3)
          </pre>
          <p>appears as the specified list in the default object. 
A function like this:
          <pre class="example">               :initform +
          </pre>
          <p>is quoted in as a symbol.

          <!-- This feature was more annoying than useful.  Use the -->
<!-- `initialize-instance' function to do this. -->
<!-- On the other hand, if you need code to be -->
<!-- executed at instantiation time as the initform, code like this: -->
<!-- @example -->
<!-- :initform (lambda () (+ 1 some-global-var)) -->
<!-- @end example -->
<!-- will be identified as a function call, and be executed in place. -->
<p><a name="index-lambda_002ddefault-2"></a>Lastly, using the function <code>lambda-default</code> instead of
<code>lambda</code> will let you specify a lambda expression to use as the
value, without evaluation. 
<br><dt><code>:type</code><dd>An unquoted type specifier used to validate data set into this slot. 
See <a href="../cl/Type-Predicates.html#g_t_0028cl_0029Type-Predicates">(cl)Type Predicates</a>. 
Here are some examples:
               <dl>
 <dt><code>symbol</code><dd> A symbol. 
 <br><dt><code>number</code><dd> A number type
 <br><dt><code>my-class-name</code><dd> An object of your class type. 
 <br><dt><code>(or null symbol)</code><dd> A symbol, or nil. 
 <br><dt><code>function</code><dd> A function symbol, or a <code>lambda-default</code> expression. 
 </dl>
          <br><dt><code>:allocation</code><dd>Either :class or :instance (defaults to :instance) used to
specify how data is stored.  Slots stored per instance have unique
values for each object.  Slots stored per class have shared values for
each object.  If one object changes a :class allocated slot, then all
objects for that class gain the new value. 
<br><dt><code>:documentation</code><dd>Documentation detailing the use of this slot.  This documentation is
exposed when the user describes a class, and during customization of an
object. 
</dl>

        <p>Some tags whose behaviors do not yet match CLOS are:

          <dl>
<dt><code>:accessor</code><dd>Name of a generic function which can be used to fetch the value of this slot. 
You can call this function later on your object and retrieve the value
of the slot. 
<br><dt><code>:writer</code><dd>Name of a generic function which will write this slot. 
<br><dt><code>:reader</code><dd>Name of a generic function which will read this slot. 
</dl>

        <p>Some tags which are unique to EIEIO are:

          <dl>
<dt><code>:custom</code><dd>A custom :type specifier used when editing an object of this type. 
See documentation for <code>defcustom</code> for details.  This specifier is
equivalent to the :type field of a <code>defcustom</code> call. 
<br><dt><code>:label</code><dd>When customizing an object, the value of :label will be used instead
of the slot name.  This enables better descriptions of the data than
would usually be afforded. 
<br><dt><code>:group</code><dd>Similar to <code>defcustom</code>'s :group command, this organizes different
slots in an object into groups.  When customizing an object, only the
slots belonging to a specific group need be worked with, simplifying the
size of the display. 
<br><dt><code>:protection</code><dd>A CLOS unsupported specifier which indicates that only methods of this
class may access this slot.

          <p>When using a slot referencing function, if the value behind <var>slot</var>
is private or protected, then the current scope of operation must be
within a method of the calling object.

          <p>Valid values are:

               <dl>
<dt><code>:public</code><dd>Anyone may access this slot from any scope. 
<br><dt><code>:protected</code><dd>Only methods of the same class, or of a child class may access this
slot. 
<br><dt><code>:private</code><dd>Only methods of the same class as this slot's definition may access
this slot. 
</dl>

        </dl>

        <p>Additionally, CLOS style class options are available.  These are various
options attached to a class.  These options can occur in place or in
addition to a documentation string.  If both occur, then the options
appear before the documentation string.  In CLOS, documentation is one
of the options available to a class, so the ability to have a standalone
documentation string is specific to Emacs.

        <p>Possible class options are:
          <dl>
<dt><code>:documentation</code><dd>Doc string to use for this class.  If an Emacs style documentation
string is also provided, then this option is ignored. 
<br><dt><code>:allow-nil-initform</code><dd>This is not a CLOS option.

          <p>If this option is non-nil, and the <code>:initform</code> is <code>nil</code>, but
the <code>:type</code> is specifies something such as <code>string</code> then allow
this to pass.  The default is to have this option be off.  This is
implemented as an alternative to unbound slots. 
<br><dt><code>:abstract</code><dd>This is not a CLOS option.

          <p>Tags a class as being abstract, or uninstantiable. 
<br><dt><code>:custom-groups</code><dd>This is a list of groups that can be customized within this class.  This
slot is auto-generated when a class is created and need not be
specified.  It can be retrieved with the <code>class-option</code> command,
however, to see what groups are available. 
<br><dt><code>:metaclass</code><dd>Unsupported CLOS option.  Enables the use of a different base class other
than <code>standard-class</code>. 
<br><dt><code>:default-initargs</code><dd>Unsupported CLOS option.  Specifies a list of initargs to be used when
creating new objects.  As far as I can tell, this duplicates the
function of <code>:initform</code>. 
</dl>

        <p>See <a href="CLOS-compatibility.html#CLOS-compatibility">CLOS compatibility</a>, for more details on CLOS tags versus EIEIO
specific tags.

        <p>The whole definition may look like this:
     <pre class="example">          (defclass data-object ()
            ((value :initarg :value
          	  :initform nil
          	  :accessor get-value
          	  :documentation
                    "Lisp object which represents the data this object maintains."
          	  :protection :protected)
             (reference :initarg :reference
          	      :initform nil
                        :type list
                        :custom (repeat object)
          	      :documentation
                        "List of objects looking at this object.
          The method `update-symbol' is called for each member of `reference' whenever
          `value' is modified."
          	      :protection :protected)
             )
            "Data object which tracks referencers.")
     </pre>
        </blockquote></div>

<div class="defun">
&mdash; Variable: <b>eieio-error-unsupported-class-tags</b><var><a name="index-eieio_002derror_002dunsupported_002dclass_002dtags-3"></a></var><br>
<blockquote><p>If Non-nil, then <code>defclass</code> will throw an error if a tag
in a slot specifier is unsupported. 
</p></blockquote></div>

   </body></html>

